package oesf.ace;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothServerSocket;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

/**
 * 6.3@Bluetooth
 */
// Xg6-3-1@BluetoothONɂTvvO
// Xg6-3-2@foCX邽߂̃TvvO
// Xg6-3-3@ foCX̃ANVCegM
// Xg6-3-4@ANVCegBroadcastReceiver̓o^
// Xg6-3-5@yAOς݃foCX̃foCXƐڑTvvO
// Xg6-3-6@foCX̃TvvO
// Xg6-3-7@[gfoCX̐ڑv̎t̃TvvO

public class BluetoothSampleActivity extends Activity {

	public static final String DEFAULT_DEVICE_NAME = "Sample";
	public static final int MESSAGE_READ = 100;
	public static final int MESSAGE_TOAST = 200;
	public static final String TOAST = "toast";
	public static final int REQUEST_BT_ENABLE = 0;
	public static final int REQUEST_BT_DISCOVERABLE = 1;

	private Button enableButton;
	private Button discoverButton;
	private Button connButton;
	private Button resButton;
	private Button acceptButton;
	private EditText conDevive;

	private BluetoothSocket btSocket = null;
	private DataOutputStream dos = null;
	private InputThread iThread = null;
	private AcceptThread aThread = null;
	private BluetoothAdapter btAdapter = null;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		conDevive = (EditText) findViewById(R.id.conDeviceName);
		conDevive.setText(DEFAULT_DEVICE_NAME);
		initEnableButton();
		initDiscoverButton();
		initConnButton();
		initResButton();
		initAcceptButton();
		IntentFilter filter = new IntentFilter();
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_STARTED);
		filter.addAction(BluetoothAdapter.ACTION_DISCOVERY_FINISHED);
		filter.addAction(BluetoothDevice.ACTION_FOUND);
		registerReceiver(mReceiver, filter);
	}

	private void initEnableButton() {
		enableButton = (Button) findViewById(R.id.enable_button);
		enableButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {

				btAdapter = BluetoothAdapter.getDefaultAdapter();
				if (btAdapter == null) {
					Toast.makeText(getApplicationContext(),
							"Bluetooth is not supported!", Toast.LENGTH_SHORT)
							.show();
					return;
				}

				if (btAdapter.isEnabled()) {
					Toast.makeText(getApplicationContext(),
							"Now Bluetooth is enable!", Toast.LENGTH_SHORT)
							.show();
				} else {
					Intent intent = new Intent(
							BluetoothAdapter.ACTION_REQUEST_ENABLE);
					startActivityForResult(intent, REQUEST_BT_ENABLE);
				}
			}
		});
	}

	@Override
	protected void onActivityResult(int reqestCode, int resultCode, Intent data) {
		if (reqestCode == REQUEST_BT_ENABLE) {
			if (resultCode == Activity.RESULT_OK) {
				Toast.makeText(getApplicationContext(),
						"Now Bluetooth is enable!", Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(getApplicationContext(),
						"Bluetooth is not enable!", Toast.LENGTH_SHORT).show();
			}
		} else if (reqestCode == REQUEST_BT_DISCOVERABLE) {
			if (resultCode != Activity.RESULT_CANCELED) {
				Toast.makeText(getApplicationContext(),
						"Now Bluetooth is discoverable!" + resultCode + "sec",
						Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(getApplicationContext(),
						"Device is not discoverable!", Toast.LENGTH_SHORT)
						.show();
			}
		}
	}

	private void initDiscoverButton() {
		discoverButton = (Button) findViewById(R.id.discover_button);
		discoverButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (btAdapter == null) {
					btAdapter = BluetoothAdapter.getDefaultAdapter();
				}
				if (btAdapter.isDiscovering()) {
					btAdapter.cancelDiscovery();
				}
				btAdapter.startDiscovery();
			}
		});
	}

	private List<String> newDeviceList = new ArrayList<String>();
	private BroadcastReceiver mReceiver = new BroadcastReceiver() {
		public void onReceive(Context context, Intent intent) {

			String action = intent.getAction();
			if (BluetoothAdapter.ACTION_DISCOVERY_STARTED.equals(action)) {
				Toast.makeText(getApplicationContext(),
						"Device descovery start!", Toast.LENGTH_SHORT).show();

			} else if (BluetoothDevice.ACTION_FOUND.equals(action)) {
				BluetoothDevice device = intent
						.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				String name = device.getName();
				newDeviceList.add(name);
			} else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED
					.equals(action)) {
				btAdapter.cancelDiscovery();
				Toast.makeText(getApplicationContext(),
						"Device descovery finished!", Toast.LENGTH_SHORT)
						.show();
				for (String device : newDeviceList) {
					Log.i("Discover Device !! ", "device name = " + device);
				}
				if (mReceiver != null) {
					unregisterReceiver(mReceiver);
					mReceiver = null;
				}
			}
		}
	};

	private void initConnButton() {
		connButton = (Button) findViewById(R.id.con_button);
		connButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (btSocket == null) {
					try {
						BluetoothAdapter btAdapter = BluetoothAdapter
								.getDefaultAdapter();
						Set<BluetoothDevice> bondedDevices = btAdapter
								.getBondedDevices();
						BluetoothDevice remoteDevice = null;

						for (BluetoothDevice bluetoothDevice : bondedDevices) {
							if (bluetoothDevice.getName().equals(
									conDevive.getText().toString())) {
								remoteDevice = bluetoothDevice;
								break;
							}
						}

						if (remoteDevice == null) {
							Toast toast = Toast.makeText(
									getApplicationContext(),
									"No paired Sample Device found",
									Toast.LENGTH_SHORT);
							toast.show();
							return;
						}

						btSocket = remoteDevice.createRfcommSocketToServiceRecord(UUID
								.fromString("00001101-0000-1000-8000-00805F9B34FB"));
						btSocket.connect();
						dos = new DataOutputStream(btSocket.getOutputStream());
					} catch (IOException e) {
						connectionLost();
						return;
					}
				}

				if (dos != null) {
					// bZ[WM҂Xbh
					iThread = new InputThread(btSocket);
					iThread.start();
					// M
					sendBTMessage("Hello!");
				} else {
					// ڑłȂꍇ͐ؒf
					connectionLost();
				}
			}
		});
	}

	public void sendBTMessage(String str) {
		if (dos == null) {
			return;
		}
		try {
			dos.writeUTF(str);
			dos.flush();
		} catch (IOException ioe) {
			connectionLost();
		}
	}

	private class InputThread extends Thread {
		private final InputStream mmInStream;

		public InputThread(BluetoothSocket socket) {
			InputStream tmpIn = null;

			try {
				tmpIn = socket.getInputStream();
			} catch (IOException e) {
			}
			mmInStream = tmpIn;
		}

		public void run() {
			byte[] buffer = new byte[256];
			int bytes;
			while (true) {
				try {
					bytes = mmInStream.read(buffer);
					mHandler.obtainMessage(MESSAGE_READ, bytes, -1, buffer)
							.sendToTarget();
				} catch (IOException e) {
					connectionLost();
					break;
				}
			}
		}
	}

	private void connectionLost() {
		Message msg = mHandler.obtainMessage(MESSAGE_TOAST);
		Bundle bundle = new Bundle();
		bundle.putString(TOAST, "Device connection was lost");
		msg.setData(bundle);
		mHandler.sendMessage(msg);
		destroyBTConnection();
	}

	private final Handler mHandler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			case MESSAGE_READ:
				byte[] readBuf = (byte[]) msg.obj;
				String readMessage = new String(readBuf, 0, msg.arg1);
				Log.i("From Remote device", readMessage);
				break;
			case MESSAGE_TOAST:
				Toast.makeText(getApplicationContext(),
						msg.getData().getString(TOAST), Toast.LENGTH_SHORT)
						.show();
				break;
			}
		}
	};

	private void initResButton() {
		resButton = (Button) findViewById(R.id.res_button);
		resButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {

				if (btAdapter == null) {
					btAdapter = BluetoothAdapter.getDefaultAdapter();
				}

				if (btAdapter.isEnabled()) {
					Intent intent = new Intent(
							BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
					startActivityForResult(intent, REQUEST_BT_DISCOVERABLE);
				} else {
					Toast toast = Toast.makeText(getApplicationContext(),
							"Bluetooth is not enable!", Toast.LENGTH_SHORT);
					toast.show();
					return;
				}
			}
		});
	}

	private void initAcceptButton() {
		acceptButton = (Button) findViewById(R.id.accept_button);
		acceptButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				aThread = new AcceptThread();
				aThread.start();
			}
		});
	}

	private class AcceptThread extends Thread {
		private final BluetoothServerSocket serverSocket;
		private boolean isClosedSocket = true;

		public AcceptThread() {
			BluetoothServerSocket tmp = null;
			synchronized (this) {
				try {
					if (btAdapter == null) {
						btAdapter = BluetoothAdapter.getDefaultAdapter();
					}
					if (btAdapter.isEnabled()) {
						tmp = btAdapter
								.listenUsingRfcommWithServiceRecord(
										"SampleServerConn",
										UUID.fromString("00001101-0000-1000-8000-00805F9B34FB"));
					} else {
						Toast toast = Toast.makeText(getApplicationContext(),
								"Bluetooth is not enable!", Toast.LENGTH_SHORT);
						toast.show();
						connectionLost();
					}
				} catch (IOException e) {
					e.printStackTrace();
					connectionLost();
				}
				serverSocket = tmp;
				isClosedSocket = false;
			}
		}

		public void run() {
			BluetoothSocket socket = null;
			Message msg1 = mHandler.obtainMessage(MESSAGE_TOAST);
			Bundle bundle1 = new Bundle();
			bundle1.putString(TOAST, "Now waiting for ServerSocket accept!");
			msg1.setData(bundle1);
			mHandler.sendMessage(msg1);

			while (!isClosedSocket) {
				try {
					socket = serverSocket.accept();
				} catch (IOException e) {
					e.printStackTrace();
					Message msg2 = mHandler.obtainMessage(MESSAGE_TOAST);
					Bundle bundle2 = new Bundle();
					bundle2.putString(TOAST, "ServerSocket can not connect");
					msg2.setData(bundle2);
					mHandler.sendMessage(msg2);
					cancel();
					break;
				}
				if (socket != null) {
					synchronized (this) {

						// NCAg̃foCXڑ
						// ڑ̃foCXƂ̃f[^MBluetoothSocketIuWFNg
						// InputStreamAOutputStreamōs

						cancel();// T[o\Pbg鏈
						break;
					}
				}
			}
		}

		public void cancel() {
			if (isClosedSocket) {
				return;
			}
			try {
				serverSocket.close();
				isClosedSocket = true;
			} catch (IOException e) {
				e.printStackTrace();
				connectionLost();
			}
		}
	}

	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	public void onPause() {
		destroyBTConnection();
		super.onStop();
	}

	private void destroyBTConnection() {
		try {
			if (btSocket != null) {
				btSocket.close();
				btSocket = null;
			}
			if (iThread != null && iThread.isAlive()) {
				iThread.stop();
				iThread = null;
			}
			if (aThread != null && aThread.isAlive()) {
				aThread.cancel();
				aThread = null;
			}
			if (dos != null) {
				dos = null;
			}
			if (mReceiver != null) {
				unregisterReceiver(mReceiver);
				mReceiver = null;
			}

		} catch (IOException e) {
			Toast toast = Toast.makeText(this,
					"Problem at closing the connection", Toast.LENGTH_SHORT);
			toast.show();
		}
	}

}